Index: libguile/__scm.h
--- libguile/__scm.h.orig	2003-04-12 19:24:56 +0200
+++ libguile/__scm.h	2004-11-29 19:59:51 +0100
@@ -354,7 +354,8 @@
  * that all the state of the process is contained in the stack. 
  */
 
-#if defined (sparc) || defined (__sparc__) || defined (__sparc)
+#if (defined (sparc) || defined (__sparc__) || defined (__sparc)) && \
+    (!defined(__FreeBSD__))
 # define SCM_FLUSH_REGISTER_WINDOWS asm("ta 3")
 #else
 # define SCM_FLUSH_REGISTER_WINDOWS /* empty */
Index: libguile/gc_os_dep.c
--- libguile/gc_os_dep.c.orig	2004-06-16 00:55:31 +0200
+++ libguile/gc_os_dep.c	2004-11-29 19:59:51 +0100
@@ -107,6 +107,14 @@
 #    define OPENBSD
 #    define mach_type_known
 # endif
+# if defined(__FreeBSD__) && defined(__sparc__)
+#    define FREEBSD
+#    include <machine/frame.h>
+#    define ALIGNMENT 8
+#    define CPP_WORDSZ 64
+#    define ALIGN_DOUBLE
+#    define mach_type_known
+# endif
 # if defined(__NetBSD__) && defined(__powerpc__)
 #    define POWERPC
 #    define NETBSD
@@ -239,7 +247,11 @@
 #    define ARM32
 #    define mach_type_known
 # endif
-# if defined(__alpha) || defined(__alpha__)
+# if defined(__FreeBSD__) && defined(__alpha__)
+#   define FREEBSD
+#   define ALPHA
+#   define mach_type_known
+# elif defined(__alpha) || defined(__alpha__)
 #   define ALPHA
 #   if !defined(LINUX)
 #     define OSF1	/* a.k.a Digital Unix */
@@ -1489,7 +1501,7 @@
 #   include <setjmp.h>
 #endif
 
-#ifdef FREEBSD
+#if defined(FREEBSD) && defined(I386)
 #  include <machine/trap.h>
 #endif
 
Index: libguile/guile.c
--- libguile/guile.c.orig	2002-12-07 23:41:32 +0100
+++ libguile/guile.c	2005-10-14 15:49:54 +0200
@@ -88,7 +88,7 @@
 {
 #ifdef DYNAMIC_LINKING
   /* libtool automagically inserts this variable into your executable... */
-  extern const scm_lt_dlsymlist lt_preloaded_symbols[];
+  extern const scm_lt_dlsymlist *lt_preloaded_symbols;
   scm_lt_dlpreload_default (lt_preloaded_symbols);
 #endif
   scm_boot_guile (argc, argv, inner_main, 0);
